function ChatGui:_create_input_panel()
	self._input_panel = self._panel:panel( { alpha = 0, name = "input_panel", x = 0, h = 24, w = self._panel_width, layer = 1 } )
	-- self._input_panel:rect( { color = Color( math.rand( 1 ), math.rand( 1 ), 0 ):with_alpha( 0.2 ) } )
	self._input_panel:rect( { name = "focus_indicator", visible = false, color = Color.black:with_alpha( 0.2 ), layer = 0 } )
	
	local say = self._input_panel:text( { name = "say", text = utf8.to_upper( managers.localization:text( "debug_chat_say" ) ), font = tweak_data.menu.small_font, font_size = tweak_data.menu.small_font_size, x = 0, y = 0,
									align="left", halign="left", vertical="center", hvertical="center", blend_mode="normal",
									color = Color.white, layer = 1 } )
	local _,_,w,h = say:text_rect()
	say:set_size( w, self._input_panel:h() )
	
	local input_text = self._input_panel:text( { name = "input_text", text = "", font = tweak_data.menu.small_font, font_size = tweak_data.menu.small_font_size, x = 0, y = 0,
									align="left", halign="left", vertical="center", hvertical="center", blend_mode="normal",
									color = Color.white, layer = 1, wrap = true, word_wrap = false } )
	local caret = self._input_panel:rect( { name="caret", layer = 2, x = 0, y = 0, w = 0, h = 0, color = Color(0.05, 1, 1, 1) } )
	
	self._input_panel:rect( { name="input_bg", color=Color.black:with_alpha(0.5), layer = -1, valign = "grow", h = self._input_panel:h() } ) -- gradient( { name = "input_bg", gradient_points = { 0, Color.white:with_alpha( 0.0 ), 0.2, Color.white:with_alpha( 0.25 ), 1, Color.white:with_alpha( 0.0 ) }, layer = -1, valign = "grow", blend_mode = "sub", h = self._input_panel:h() } )
	self._input_panel:child( "input_bg" ):set_w( self._input_panel:w() - w )
	self._input_panel:child( "input_bg" ):set_x( w )
	
	self._input_panel:stop()
	self._input_panel:animate( callback( self, self, "_animate_hide_input" ) )
	self._input_panel:gradient( { name = "input_bg", gradient_points = { 0, Color.black:with_alpha( 0.25 ), 1, Color.black:with_alpha( 0.25 ) }, layer = -1, valign = "grow", h = self._input_panel:h() } )
end

function ChatGui:receive_message(name, message, color, icon)
	if not alive(self._panel) or not managers.network:session() then
		return
	end

	local output_panel = self._panel:child("output_panel")
	local scroll_panel = output_panel:child("scroll_panel")
	local local_peer = managers.network:session():local_peer()
	local peers = managers.network:session():peers()
	local len = utf8.len(name) + 1
	local x = 0
	local icon_bitmap = nil

	if icon then
		local icon_texture, icon_texture_rect = tweak_data.hud_icons:get_icon_data(icon)
		icon_bitmap = scroll_panel:bitmap({
			y = 1,
			texture = icon_texture,
			texture_rect = icon_texture_rect,
			color = color
		})
		x = icon_bitmap:right()
	end

	local line = scroll_panel:text( { text = name..": "..message, font = tweak_data.menu.small_font, font_size = tweak_data.menu.small_font_size, x = 0, y = 0,
									align="left", halign="left", vertical="top", hvertical="top", blend_mode="normal", wrap = true, word_wrap = true,
									color = color, layer = 0 } )
	local total_len = utf8.len(line:text())

	line:set_range_color(0, len, color)
	line:set_range_color(len, total_len, Color.white)

	local _, _, w, h = line:text_rect()

	line:set_h(h)

	local line_bg = scroll_panel:rect({
		hvertical = "top",
		halign = "left",
		layer = -1,
		color = Color.black:with_alpha(0.5)
	})

	line_bg:set_h(h)
	line:set_kern(line:kern())
	table.insert(self._lines, {
		line,
		line_bg,
		icon_bitmap
	})
	self:_layout_output_panel()

	if not self._focus then
		output_panel:stop()
		output_panel:animate(callback(self, self, "_animate_show_component"), output_panel:alpha())
		output_panel:animate(callback(self, self, "_animate_fade_output"))
		self:start_notify_new_message()
	end
end